/**
 * Label name and data attribute's key of entity.
 */

import KeyValueItem from 'model/KeyValueItem';

type EntityFormColumnBase = {
  labelName: string,
  name: string,
  required?: boolean,
  readOnly?: boolean,
}

type EntityFormColumnInfo = {
  type: 'default' | 'textarea',
  defaultValue: string,
} | {
  type: 'number-array',
  defaultValue: number[],
} | {
  type: 'number',
  defaultValue: number,
} | {
  type: 'key-value',
  defaultValue: KeyValueItem[],
} | {
  type: 'check',
  defaultValue: boolean,
} | {
  type: 'join',
  info: {
    entityTypeId: string,
    keyColumn: string,
  },
  defaultValue: string,
} | {
  type: 'select',
  url: string,
  defaultValue: string,
} | {
  type: 'radio',
  value: { labelName: string, name: string }[],
  defaultValue: string,
  orientation: 'horizontal' | 'vertical'
};

type EntityFormColumn = (EntityFormColumnBase & EntityFormColumnInfo) | {
  type: 'time',
  labelName: string,
  hourName: string,
  minuteName: string,
  defaultValue: [string, string],
  required?: boolean,
  readOnly?: boolean,
} | {
  type: 'datetime',
  labelName: string,
  name: string,
};

export default EntityFormColumn;
