import CloudContenxtItemlabel from 'model/CloudContenxtItemLabel';
import { BsPinMapFill } from 'react-icons/bs';
import { Link } from 'react-router-dom';

/**
 * Label on CloudContenxtItemPopup.
 *
 * @param label Labeling data of CloudContenxtItem.
 */
const CloudContenxtItemPopupLabel = ({ label }: {
  label: CloudContenxtItemlabel
}) => {

  return <div>
    <div>
      <Link to={label.entityViewUrl} target="_blank" rel="noreferrer">
        <img src={label.iconUrl} alt={label.name} />
      </Link>
    </div>
    <div>
      <strong>
        <Link to={label.entityViewUrl} target="_blank" rel="noreferrer">
          {label.name}
        </Link>
      </strong><br />
      <span className="location">
        <BsPinMapFill />
        {label.positionLabel}
      </span>
    </div>
  </div>;

};

export default CloudContenxtItemPopupLabel;
