<?php

namespace Drupal\aws_cloud\Service\CloudFormation;

use Aws\ResultInterface;

/**
 * Interacts with the AWS Cloud CloudFormation API.
 */
interface CloudFormationServiceInterface {

  /**
   * Set the cloud context.
   *
   * @param string $cloud_context
   *   Cloud context string.
   */
  public function setCloudContext($cloud_context): void;

  /**
   * Calls the Amazon CloudFormation API endpoint CreateStack.
   *
   * @param array $params
   *   Parameters array to send to API.
   *
   * @return mixed
   *   An array of results or NULL if there is an error.
   */
  public function createStack(array $params = []): ?ResultInterface;

}
