<?php

namespace Drupal\k8s\Service\K8sClientExtension\Repositories;

use Drupal\k8s\Service\K8sClientExtension\Collections\K8sMetricsNodeCollection;
use Maclof\Kubernetes\Repositories\Repository;

/**
 * K8s node repository for metrics.
 */
class K8sMetricsNodeRepository extends Repository {

  /**
   * The uri.
   *
   * @var string
   */
  protected string $uri = 'nodes';

  /**
   * Whether use namespace or not.
   *
   * @var bool
   */
  protected bool $namespace = FALSE;

  /**
   * {@inheritdoc}
   */
  protected function createCollection($response): K8sMetricsNodeCollection {
    // K8s API server may return a string '404 page not found', not an array.
    return new K8sMetricsNodeCollection(is_array($response)
      ? $response['items']
      : ['items' => []]
    );
  }

  /**
   * {@inheritdoc}
   */
  protected function getApiVersion(): string {
    return 'metrics.k8s.io/v1beta1';
  }

}
