@minimal @ci_job
Feature: Create and launch a launch template for K8s as "Authenticated User" and
  approve it as "Cloud administrator"

  @api @javascript
  Scenario: Create a Launch template
    Given I am logged in as user "{{ user_name }}"
    When I visit "clouds/design/server_template/{{ cloud_context }}/k8s/add"
    And I enter "{{ launch_yaml_name }}" for "Name"
    And I select "{{ namespace }}" from "Namespace"
    And I click "YAML"
    And I enter "{{ launch_yaml_repository }}" for "YAML URL"
    And I select "Draft" from "Workflow status"
    And I press "Save"
    And I wait for AJAX to finish
    Then the url should match "/clouds/design/server_template/{{ cloud_context }}"
    And I should see the success message "{{ launch_yaml_name }} has been created"
    And I should see neither error nor warning messages

  @api @javascript
  Scenario: Approve the launch template
    Given I am logged in as a user with the "Cloud administrator" role
    When I visit "/clouds/design/server_template/{{ cloud_context }}"
    And I click "Edit" in the "{{ launch_yaml_name }}" row
    And I select "{{ namespace }}" from "Namespace"
    And I select "Approved" from "Workflow status"
    And I press "Save"
    And I wait for AJAX to finish
    Then the url should match "/clouds/design/server_template/{{ cloud_context }}"
    And I should see the success message "{{ launch_yaml_name }} has been updated"
    And I should see neither error nor warning messages

  @api @javascript
  Scenario: Launch a Launch template
    Given I am logged in as user "{{ user_name }}"
    When I visit "/clouds/design/server_template/{{ cloud_context }}"
    And I click "{{ launch_yaml_name }}"
    And I click "Launch"
    And the url should match "/launch"
    And I press "Launch"
    And I wait for AJAX to finish
    Then the url should match "/clouds/k8s/{{ cloud_context }}/pod"
    And I should see the success message "{{ launch_yaml_pod1 }} has been launched"
    And I should see neither error nor warning messages

  @api @javascript
  Scenario: Delete a Launch template
    Given I am logged in as user "{{ user_name }}"
    When I visit "/clouds/design/server_template/{{ cloud_context }}"
    And I click "Edit" in the "{{ launch_yaml_name }}" row
    And I click "Delete"
    And the url should match "/delete"
    And I press "Delete"
    And I wait for AJAX to finish
    Then the url should match "/clouds/design/server_template/{{ cloud_context }}"
    And I should see the success message "{{ launch_yaml_pod1 }} (Namespace: {{ namespace }}) on {{ cloud_context }} has been deleted"
    And I should see the success message "{{ launch_yaml_name }} has been deleted"
    And I should see neither error nor warning messages
    And I should not see the link "{{ launch_yaml_name }}"

  @api @javascript
  Scenario: Check if the Pod has been deleted
    Given I am logged in as user "{{ user_name }}"
    When I visit "/clouds/k8s/{{ cloud_context }}/event"
    And I click "Created"
    Then I should see "Killing" in the "{{ launch_yaml_pod1 }}" row
